package com.bonait.bnframework.common.constant;

import android.content.Context;

import com.bonait.bnframework.common.db.mode.BPA_USER;
import com.bonait.bnframework.common.model.mode.DeviceInformation;
import com.bonait.bnframework.common.model.mode.OrganizeMode;

import java.util.HashMap;
import java.util.LinkedHashMap;


/**
 * 配置文件
 */
public class ConfigName {
    //region 单例模式
    private static ConfigName  mInstance; //实例变量设置私有，防止直接通过类名访问

    private ConfigName() { //默认构造函数私有，防止类外直接new创建对象
    }

    public static synchronized ConfigName getInstance() { //静态同步方法作为唯一的实例对象获取方式
        if (mInstance==null) {
            mInstance = new ConfigName();
        }
        return mInstance;
    }
    //endregion

    //region 程序进入界面
    public Context dishesCon;
    public Context Home;
    //endregion

    //region SD卡路径设置
    /**
     * SD卡路径
     */
    public String sdCardPath;
    /**
     * 应用程序 Res 根路径
     */
    public String appResRoot;
    /**
     * Db文件路径
     */
    public static String dbPath = "";
    //endregion

    //region 店铺配置
    /**
     * 店铺名称
     */
    public String  Shop_Name="黑菠萝奶茶机";
    /**
     * 门店Id
     */
    public String ClientAutoKey="152";
    /**
     * 店铺设备号
     */
    public String DeviceAutoKey="146";
    /**
     * 设备id
     */
    public String DeviceId="29318217-838a-4572-982d-51773bef6249";
    //endregion

    //region MQTT配置中心
    /**
     * 用户名
     */
    public String mqtt_userName="emqx_u_block";
    /**
     * 密码
     */
    public String mqtt_passWord="emqx_p_admin8765490789";
    /**
     * ip地址
     */
    public String mqtt_ip="10.2.1.21";
    /**
     * post端口
     */
    public int mqtt_post=1883;
    /**
     * 订阅主题
     */
    public String mqtt_topic="DOWN/MORKT/BUSINESS/";
    public String mqtt_hearttopic="UP/MORKT/HEARTBEAT";
    //endregion

    //region 环境配置
    /**
     * 环境配置
     */
    public String Environment="开发环境";
    //endregion

    //region 登录信息
    /**
     * 用户信息
     */
    public BPA_USER user=new BPA_USER();
    //endregion

    //region 组织信息
    /**
     * 组织信息
     */
    public OrganizeMode organizeMode=null;
    /**
     * 设备信息
     */
    public DeviceInformation deviceInformation=null;
    //endregion

    //region 版本信息
    /**
     * 版本更新，当前版本
     */
    public String Version="1.0";
    //endregion

    //region 是否手动下单
    /**
     * 是否手动下单
     */
    public Boolean IsUserDownOrder=false;
    //endregion

    //region 系统设置表
    /**
     * 订单上报周期，默认一小时 *60
     */
    public int OrderPushTime=3600;
    /**
     * 料仓余量上报周期，默认10分钟 *60
     */
    public int SilosValuePushTime=600;
    /**
     * 其他传感器上报周期，默认10分钟 *60
     */
    public int OtherValuePushTime=600;
    /**
     * 管道排空周期，默认一小时 *60
     */
    public int PipeDrainCycleTime=3600;
    /**
     * 订单未制作超时规则，默认20分钟 *60
     */
    public int OrderTimeout=1200;
    /**
     * 料仓补料阈值，500g
     */
    public int SiloFeedThreshold=500;
    /**
     * 料仓告警阈值，50g
     */
    public int SiloAlarmThreshold=50;
    /**
     * 自动清洗时间，默认一小时 *60
     */
    public int AICleanTime=3600;
    //endregion

    //region PlC连接参数
    /**
     * Plc地址
     */
    public String Address="192.168.1.100";
    /**
     * Plc端口
     */
    public int Post=502;
    //endregion

    //region URL
    //Sass地址
    public String SaasAddress="http://order.test1.com";
    //public String SaasAddress="https://bpa.black-pa.com:21527";
    //public String SaasAddress="https://witt.black-pa.com";

    //获取店铺详细信息 Get
    public String GetStore="kitchen/api/StoreHelper/GetStoreInfoById?storeId=";
    //获取设备信息分页 Get
    public String GetDeviceInformation="kitchen/api/Device/GetDeviceInfo?storeId=%s&autoKey=%s";
    //获取 获取基础信息（所有物料信息、设备工序模型、菜谱列表、商品小类、商品大类、单位数据
    public String GetBaseDataModel="kitchen/api/CommInteface/GetBaseDataModel?storeId=%s&autoKey=%s";
    //获取 商品
    public String GetGoods="kitchen/api/CommInteface/GetDeviceGood?storeId=%s&deviceId=%s";
    //获取商品配方信息
    public String GetGoodsBom="kitchen/api/CommInteface/GetDeviceGoodBomTechnology?goodsId=%s";
    //上传商品
    public String UpdateGoods="kitchen/api/CommInteface/SendGoodsInfo";
    //版本更新
    public String UpdateVersion="http://111.9.47.105:18097/api/Version/GetLatest";
    //endregion

    //region PLC地址配置
    /**
     * PLC地址配置
     */
    public HashMap<String,String> PlcAddress=new HashMap<String,String>();
    public LinkedHashMap<String,String> PlcAddress_ys=new LinkedHashMap<String,String>(){
        {
            //硬件设备 初始化
            put("硬件设备","-------------");
            put("初始化", "M10.0");
            put("停止", "M10.1");
            put("复位", "M10.2");


            //搅拌模型
            put("模型控制","-------------" );
            put("搅拌", "M10.3"); //搅拌启停
            put("搅拌速度", "VW102");

            //翻转正转模型
            put("翻转正转", "M10.4");
            put("正转速度", "VW104");

            //翻转反转模型
            put("翻转反转", "M10.5");
            put("反转速度", "VW104");

            //加热模型
            put("加热", "M10.6");
            put("加热功率", "VW100");

            //抽水放水
            put("炒锅抽水", "M10.7");
            put("炒锅放水", "M11.0");

            //出菜模型
            put("出菜", "M11.5");

            //位置动作
            put("原点位", "M11.4");
            put("出餐位", "M11.5");
            put("倒菜位", "M12.7");
            put("抽料位", "M11.7");
            put("清洗位", "M13.0");
            put("炒菜位1", "M12.0");
            put("炒菜位2", "M12.1");
            put("炒菜位3", "M12.2");

            put("炒锅清洗", "M11.6");

            put("液体料","-------------" );
            //液体料模型
            put("开始校正", "M12.6");
            put("校准时间", "VW112");
            put("料仓1", "M11.1");
            put("料仓2", "M11.2");
            put("料仓3", "M11.3");
            put("通道1手动", "M12.3");//手动
            put("通道2手动", "M12.4");
            put("通道3手动", "M12.5");

            put("料仓1校准值", "VW114");
            put("料仓2校准值", "VW116");
            put("料仓3校准值", "VW118");


            put("料仓1", "M11.1");
            put("料仓2", "M11.2");
            put("料仓3", "M11.3");

            //上下限
            put("位置上下限","-------------");
            put("原点位置下限", "VD150");
            put("原点位置上限", "VD152");
            put("洗锅位置下限", "VD154");
            put("洗锅位置上限", "VD156");
            put("倒菜位置下限", "VD158");
            put("倒菜位置上限", "VD160");
            put("抽调料位置下限", "VD162");
            put("抽调料位置上限", "VD164");
            put("1#炒制位置下限", "VD166");
            put("1#炒制位置上限", "VD168");
            put("2#炒制位置下限", "VD170");
            put("2#炒制位置上限", "VD172");
            put("3#炒制位置下限", "VD174");
            put("3#炒制位置上限", "VD176");
            put("炒锅工作范围下限", "VD178");
            put("炒锅工作范围上限", "VD180");

            put("反馈信号-基本","-------------");
            put("初始化完成", "M40.0");
            put("设备急停", "M40.1");
            put("炒锅在原点位置", "M40.2");
            put("抽料位置反馈", "M40.3");
            put("炒制位置1反馈", "M40.4");
            put("炒制位置2反馈", "M40.5");
            put("炒制位置3反馈", "M40.6");
            put("炒锅在出餐倒菜位置反馈", "M40.7");
            put("炒锅在投料位置反馈", "M41.0");
            put("炒锅在洗锅位置反馈", "M41.1");
            put("通道1出料完成", "M41.2");
            put("通道2出料完成", "M41.3");
            put("通道3出料完成", "M41.4");
            put("清洗完成", "M41.5");
            put("倒菜完成", "M41.6");
            put("炒锅倒菜减速位", "M41.7");

            put("监测信号-基本", "-------------");
            put("当前锅底温度", "VW300");
            put("炒锅搅拌转速", "VW302");
            put("当前加热档位", "VW304");
            put("炒锅当前电压", "VW306");
            put("炒锅当前电流", "VW308");
            put("炒锅当前功率", "VW310");
            put("搅拌频率", "VW312");
            put("搅拌电机电压", "VW314");
            put("搅拌电机电流", "VW316");
            put("搅拌变频器温度", "VW318");
            put("翻转频率", "VW320");
            put("翻转电机电压", "VW322");
            put("翻转电机电流", "VW324");
            put("翻转变频器温度", "VW326");
            put("编码器当前位值", "VW328");
        }
    };
    //endregion
}



//配方信息
//{
//        "statusCode": 200,
//        "data": {
//        "bomInfo": [
//        {
//        "name": "爆炒肥肠",
//        "code": "10005",
//        "isMain": true,
//        "autoKey": 1099,
//        "bomInfo": null,
//        "sort": 2,
//        "groupId": "4cc8935c-9519-4a3c-a2fd-b49ca54f6f0d",
//        "status": 0,
//        "isDeleted": 0,
//        "deleteAt": null,
//        "deleteBy": null,
//        "updateAt": null,
//        "updateBy": null,
//        "createAt": "2023-07-10 16:11:41",
//        "createBy": "af27ebbd-5c1a-441f-8e26-cf6cc1352349",
//        "id": "5c4f80d9-13f3-4dcf-9cca-db4d37ffc9d0"
//        }
//        ],
//        "bomTechnologyActionInfo": [
//        {
//        "stepName": "热油",
//        "actionJson": "[{\"TechnologyactionId\":\"a82d2621-7016-4240-b5d5-7d5e41fb4d22\",\"ActionName\":\"加热功率\",\"ActionValue\":\"三档\",\"BatchingId\":\"\"},{\"TechnologyactionId\":\"df17c307-8f15-4d20-b497-61caf5668270\",\"ActionName\":\"热油(克)\",\"ActionValue\":333,\"BatchingId\":\"\"}]",
//        "bomId": "5c4f80d9-13f3-4dcf-9cca-db4d37ffc9d0",
//        "isBatch": false,
//        "chnologyId": "f9ca0cff-ba94-4036-88f4-a5d05f8165e6",
//        "createAt": "2023-07-11 17:47:28",
//        "groupId": "4cc8935c-9519-4a3c-a2fd-b49ca54f6f0d",
//        "isDeleted": 0,
//        "sort": 6,
//        "id": "7c3a5fe9-f1c6-4578-b6a8-a09006740d69"
//        },
//        {
//        "stepName": "液体料",
//        "actionJson": "[{\"TechnologyactionId\":\"10915b41-268e-4d04-b259-8e4c5f65bbda\",\"ActionName\":\"酱油\",\"ActionValue\":\"10\",\"BatchingId\":\"210f346d-8b79-4059-a991-b22391e5193f\"},{\"TechnologyactionId\":\"897bc239-ba70-4cde-bd99-c4bb14219b04\",\"ActionName\":\"盐水\",\"ActionValue\":\"20\",\"BatchingId\":\"33a529a3-de63-49c0-aed0-ea83e852050b\"}]",
//        "bomId": "5c4f80d9-13f3-4dcf-9cca-db4d37ffc9d0",
//        "isBatch": true,
//        "chnologyId": "315b149d-53bd-4fa0-9694-bf1d47ef9ba3",
//        "createAt": "2023-07-11 17:36:46",
//        "groupId": "4cc8935c-9519-4a3c-a2fd-b49ca54f6f0d",
//        "isDeleted": 0,
//        "sort": 5,
//        "id": "a9e95580-89ba-400c-a91f-53fefbabb627"
//        }
//        ]
//        },
//        "succeeded": true,
//        "errors": null,
//        "extras": null,
//        "timestamp": 1689070602181
//        }



//
//{
//        "goodsInfo": {
//        "id": "string",
//        "isDeleted": 0,
//        "deleteAt": "2023-07-11T10:17:20.548Z",
//        "deleteBy": "string",
//        "updateAt": "2023-07-11T10:17:20.548Z",
//        "updateBy": "string",
//        "createAt": "2023-07-11T10:17:20.548Z",
//        "createBy": "string",
//        "status": 0,
//        "groupId": "string",
//        "goods_Name": "string",
//        "goods_TypeID": "string",
//        "goods_Descritption": "string",
//        "goods_ImgUrl": "string",
//        "goods_ImgMode": 0,
//        "goods_Sort": 0,
//        "goods_Enable": 0,
//        "deleteUpdateTime": "2023-07-11T10:17:20.548Z",
//        "key": "string",
//        "code": "string",
//        "price": 0,
//        "tasteID": "string",
//        "parentTypeID": "string",
//        "vipPrice": 0,
//        "goodsAttribute": 0,
//        "goodsUintId": "string",
//        "isWeigh": true,
//        "autoKey": 0
//        },
//        "bomInfo": {
//        "bomType": "string",
//        "name": "string",
//        "code": "string",
//        "isMain": true,
//        "autoKey": 0,
//        "bomInfo": "string",
//        "sort": 0
//        },
//        "bomTechnologyActionInfo": [
//        {
//        "id": "string",
//        "stepName": "string",
//        "actionJson": "string",
//        "bomId": "string",
//        "isBatch": true,
//        "chnologyId": "string",
//        "createAt": "2023-07-11T10:17:20.548Z",
//        "groupId": "string",
//        "isDeleted": 0,
//        "sort": 0
//        }
//        ],
//        "foodMenuId": "string",
//        "storeId": "string"
//        }